/* Fixed Point functions: */
#include <arch.h>

CONST fixedpoint FpMult(fixedpoint a,fixedpoint b)
{
  register long res;

  __asm__ __volatile__ (
       " movl %1,%%eax \n" /* source a */
       " imull %2 \n"     /* multiply with b %eax*b=> %edx(high)+%eax(low) */
       " addl $32768,%%eax \n" /* round */
       " adcl $0,%%edx \n"      /* round */
       " shrdl $16,%%edx,%%eax \n" /* shift down */
       " movl %%eax,%0 \n"     /* store result */
       : /* output */ "=g" (res) 
       : /* input */ "%g" (a) , "g" (b)
       : /* clobbered*/ "cc","%eax","%edx"  );
       
  return res;
}

CONST fixedpoint FpDiv(fixedpoint a,fixedpoint b)
{
  register long res;
  __asm__ __volatile__ (
       " xorl %%eax,%%eax \n"
       " movl %1,%%edx \n" /* source a */
       " movl %%edx,%%ebx \n"
       " shrdl $16,%%ebx,%%eax \n"
       " sarl  $16,%%edx \n"
       " idivl %2 \n"     /* %edx(high)+%eax(low) / b */
       " movl %%eax,%0 \n"     /* store result */
       : /* output */ "=g" (res) 
       : /* input */ "g" (a) , "g" (b)
       : /* clobbered*/ "cc","%eax","%ebx","%edx"  );
       
  return res;
}

