#include <dos.h>
#include <sys/farptr.h>
#include <go32.h>
#include <stdlib.h>
#include <pc.h>

#include <conio.h>
#include <keys.h>

#include <arch.h>
#include <device.h>

/* Externally used variables: */
byte *HW_OffscreenBuffer=0;
signed_32bit HW_ScreenSizeX;
signed_32bit HW_ScreenSizeY;
signed_32bit HW_ScreenMaxX;
signed_32bit HW_ScreenMaxY;
signed_32bit HW_ScreenCenterX;
signed_32bit HW_ScreenCenterY;
unsigned_32bit HW_BytesPerRow;

/* Internal variables: */
static unsigned long LinearScreenStart;
static unsigned short LinearSelector;

int HW_OpenScreen(void)
{
  union REGS r;

  HW_ScreenSizeX=320;
  HW_BytesPerRow=320;
  HW_ScreenSizeY=200;
  HW_ScreenMaxX=HW_ScreenSizeX-1;
  HW_ScreenMaxY=HW_ScreenSizeY-1;
  HW_ScreenCenterX=(HW_ScreenSizeX/2)<<4;
  HW_ScreenCenterY=(HW_ScreenSizeY/2)<<4;


  HW_OffscreenBuffer=malloc(64000);

  if (HW_OffscreenBuffer==0) {
    return 0;
  }

  r.h.ah = 0x00; /* set video mode */
  r.h.al = 0x13; /* mode 13h */
  int86(0x10, &r, &r);

  LinearSelector=_go32_info_block.selector_for_linear_memory;
  LinearScreenStart=0xA0000;
  
  return 1;
}

void HW_DisplayScreen(void)
{
  __asm__ __volatile__ 
    (
     " push %%es \n"
     " movw _LinearSelector,%%di \n"
     " movw %%di,%%es \n"

     " movl _HW_OffscreenBuffer,%%esi \n" /* HW_OffscreenBuffer */
     " movl _LinearScreenStart,%%edi \n"    /* LinearScreenStart */
     " movl $16000,%%ecx \n" /* 16000 longs == 64000 bytes == screen size */
     " rep\n  movsl \n"

     " pop %%es \n"

     : /* output */ 
     : /* input */  
     : /* clobbered */ "cc","%ecx","%edi","%esi"
    );
}

void HW_SetPalette(byte *orgpal) 
{
  int i;
  byte pal[3*256];

  for (i=0;i<3*256;i++) {
   pal[i]=orgpal[i]>>2;
  }

  outportb(0x3c8,0);
  for (i=0;i<3*256;i++) {
   outportb(0x3c9,pal[i]);
  }
}


void HW_CloseScreen(void)
{
  union REGS r;

  r.h.ah = 0x00; /* set video mode */
  r.h.al = 0x03; /* mode 03h 80x25 */
  int86(0x10, &r, &r);

  if (HW_OffscreenBuffer) {
    free(HW_OffscreenBuffer);
  }
}


int HW_KeyboardHit(void)
{
  return kbhit();
}

int HW_GetKey(void)
{
  int c;

  c = getkey();
  switch(c) {
  case K_Home: return HW_KEY_HOME;
  case K_End: return HW_KEY_END;
  case K_Up: return HW_KEY_UP;
  case K_Down: return HW_KEY_DOWN;
  case K_Left: return HW_KEY_LEFT;
  case K_Right: return HW_KEY_RIGHT;
  case K_Space: return ' ';
  default:
    return c;
  }
}
