#ifndef DEVICE_H
#define DEVICE_H

#include <arch.h>

/* 

 Hardware interface for MSDOS / djgpp V2.0

 */

/******** Variables/Constants ********/

extern signed_32bit HW_ScreenSizeX;
extern signed_32bit HW_ScreenSizeY;
extern signed_32bit HW_ScreenMaxX;
extern signed_32bit HW_ScreenMaxY;
extern signed_32bit HW_ScreenCenterX;
extern signed_32bit HW_ScreenCenterY;
extern unsigned_32bit HW_BytesPerRow;

extern byte *HW_OffscreenBuffer;

/********* Functions: **********/

/* Screen Functions: */
int HW_OpenScreen(void);
void HW_DisplayScreen(void);
void HW_CloseScreen(void);
void HW_SetPalette(byte *pal);

/* Keyboard Functions: */
#define HW_HAS_KEYBOARD

int HW_KeyboardHit(void);
int HW_GetKey(void);
enum {
  HW_KEY_KP0=256,
  HW_KEY_KP1,
  HW_KEY_KP2,
  HW_KEY_KP3,
  HW_KEY_KP4,
  HW_KEY_KP5,
  HW_KEY_KP6,
  HW_KEY_KP7,
  HW_KEY_KP8,
  HW_KEY_KP9,
  HW_KEY_HOME,
  HW_KEY_END,
  HW_KEY_UP,
  HW_KEY_DOWN,
  HW_KEY_LEFT,
  HW_KEY_RIGHT
};


#endif /* DEVICE_H */


